using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Saving_Codec_Properties
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        //AVICompressorO[oϐ
        private TIS.Imaging.AviCompressor _selectedCodec;


        /// ICImagingControlŐݒłR[fbN擾
        /// cboVideoCodecXg{bNXɒǉ
        private void Form1_Load(object sender, EventArgs e)
        {
            // cboVideoCodecXg{bNXɒǉ
            foreach (TIS.Imaging.AviCompressor codec in TIS.Imaging.AviCompressor.AviCompressors)
            {
                cboVideoCodec.Items.Add(codec);
            }
            // 
            cboVideoCodec.SelectedIndex = 0;

            _selectedCodec = (TIS.Imaging.AviCompressor)cboVideoCodec.SelectedItem;

            // {^̗L/
            cmdShowPropertyPage.Enabled = _selectedCodec.PropertyPageAvailable;
            cmdLoadData.Enabled = _selectedCodec.PropertyPageAvailable;
            cmdSaveData.Enabled = _selectedCodec.PropertyPageAvailable;
        }


        /// IR[fbNɃvpeB_CAOꍇA{^LɂȂ܂B
        private void cboVideoCodec_SelectedIndexChanged(object sender, EventArgs e)
        {
            _selectedCodec = (TIS.Imaging.AviCompressor)cboVideoCodec.SelectedItem;
            // Enable or disable the buttons.
            cmdShowPropertyPage.Enabled = _selectedCodec.PropertyPageAvailable;
            cmdLoadData.Enabled = _selectedCodec.PropertyPageAvailable;
            cmdSaveData.Enabled = _selectedCodec.PropertyPageAvailable;
        }


        /// ShowPropertyPage\bhĂяoāAR[fbÑvpeB_CAO\܂B
        private void cmdShowPropertyPage_Click(object sender, EventArgs e)
        {
            _selectedCodec.ShowPropertyPage();
        }
        //>>


        /// R[fbNoCif[^擾AoCiŊJt@C
        /// utest.binvɕۑ܂B ۑꂽt@CgpĂR[fbN
        /// v邱ƂmF邽߂ɁAR[fbN̖Ot@Cutest.binvɕۑ܂B
        private void cmdSaveData_Click(object sender, EventArgs e)
        {
            try
            {
                System.IO.FileStream filestream = new System.IO.FileStream("test.bin", System.IO.FileMode.Create, System.IO.FileAccess.Write);
                System.IO.BinaryWriter binWriter = new System.IO.BinaryWriter(filestream);
                binWriter.Write(_selectedCodec.Name);
                binWriter.Write(_selectedCodec.CompressorDataSize);
                binWriter.Write(_selectedCodec.CompressorData);

                binWriter.Close();
                filestream.Close();
            }
            catch (Exception Ex)
            {
                MessageBox.Show(Ex.Message);
            }
        }



        /// t@Cutest.binvoCif[^[hAXg{bNXƈvĂ邩`FbN܂B

        private void cmdLoadData_Click(object sender, EventArgs e)
        {
            try
            {
                System.IO.FileStream filestream = new System.IO.FileStream("test.bin", System.IO.FileMode.Open, System.IO.FileAccess.Read);
                System.IO.BinaryReader binReader = new System.IO.BinaryReader(filestream);

                // R[fbN\t@CR[fbN̖O擾܂
                string codecName = binReader.ReadString();

                //t@C̃R[fbÑ݂R[fbN̖OƔr܂B
                if (_selectedCodec.Name == codecName)
                {
                    // oCif[^̒ǂݎ܂B
                    int codecDataLen = binReader.ReadInt32();
                    // \f[^R[fbNɊ蓖Ă܂B
                    _selectedCodec.CompressorData = binReader.ReadBytes(codecDataLen);
                }
                else
                {
                    MessageBox.Show("The saved data does not match to the used codec.\n" +
                            "saved: " + codecName + "\n" +
                            "used: " + _selectedCodec.Name);
                }
                binReader.Close();
                filestream.Close();
            }
            catch (Exception Ex)
            {
                MessageBox.Show(Ex.Message);
            }
        }
		//>>

    }
}